// CorrectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Correct.h"
#include "CorrectDlg.h"

#include "AutoCorrect.h" 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCorrectDlg dialog

CCorrectDlg::CCorrectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCorrectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCorrectDlg)
	m_strWord = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCorrectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCorrectDlg)
	DDX_Text(pDX, IDC_EDIT1, m_strWord);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCorrectDlg, CDialog)
	//{{AFX_MSG_MAP(CCorrectDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ABOUT_BOX, OnAboutBox)
	ON_BN_CLICKED(IDC_EXCEPTION, OnException)
	ON_BN_CLICKED(IDC_CORRECT_WORD, OnCorrectWord)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCorrectDlg message handlers

BOOL CCorrectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
   CAutoCorrect *pAutoCorrect = (CAutoCorrect *)GetDlgItem( IDC_AUTOCORRECT1 );
   ASSERT( pAutoCorrect != NULL);

   TCHAR szExePath[MAX_PATH];
   GetModuleFileName( AfxGetInstanceHandle(), szExePath, MAX_PATH );
   
   //remove app name from path
   CString strPath = szExePath;
   strPath = strPath.Left( strPath.ReverseFind('\\') );
   strPath += "\\";

   // create path strings
   CString strAcrPath = strPath + "test.acr";
   CString strIniPath = strPath + "test.ini";

   if( FALSE == FileExists(strAcrPath) || FALSE == FileExists(strIniPath) )
   {
      AfxMessageBox(_T("Couldn't find autocorrect files !\n Make sure that test.acr and test.ini files are in app path.") );
   }
   
    //set variant type and data
   VARIANT b;
   b.vt = VT_BSTR;
   b.bstrVal = (BSTR)(LPCSTR)strIniPath;

   //set autocorrect and ini file path
   pAutoCorrect->Initialize( strAcrPath, b );

   //translate autocorrect dialog labels
   pAutoCorrect->SetStrACDialogCaption("AutoCorrect");
   pAutoCorrect->SetStrACDlgCorrectTwoCaps("C&orrect TWo INitial CAps");
   pAutoCorrect->SetStrACDlgCapitalizeFirstLetter("Capitalize first letter of &sentence");
   pAutoCorrect->SetStrACDlgCorrectCapsLock("Correct accidental usage of cAPS &LOCK key");
   pAutoCorrect->SetStrACDlgReplace("&Replace");
   pAutoCorrect->SetStrACDlgWith("&Width");
   pAutoCorrect->SetStrACDlgButtonAdd("&Add");
   pAutoCorrect->SetStrACDlgButtonClose("Close");
   pAutoCorrect->SetStrACDlgButtonExceptions("&Exceptions...");
   pAutoCorrect->SetStrACDlgButtonChange("Change");
   pAutoCorrect->SetStrACDlgButtonDelete("Delete");
   pAutoCorrect->SetStrACDlgReplaceText("Replace text as you type");

   //translate exceptions dialog labels
   pAutoCorrect->SetStrExcDlgCaption("Exceptions");
   pAutoCorrect->SetStrExcDlgDontCapitalize("Don't capitalize");
   pAutoCorrect->SetStrExcDlgButtonClose("Close");
   pAutoCorrect->SetStrExcDlgButtonAdd("Add");
   pAutoCorrect->SetStrExcDlgButtonDelete("Delete");

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCorrectDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CCorrectDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCorrectDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCorrectDlg::OnOK() 
{
	// TODO: Add extra validation here
   CAutoCorrect *pAutoCorrect = (CAutoCorrect *)GetDlgItem( IDC_AUTOCORRECT1 );
   ASSERT( pAutoCorrect != NULL);   

   pAutoCorrect->DlgBox();
   	
	//CDialog::OnOK();
}

void CCorrectDlg::OnAboutBox() 
{
	// TODO: Add your control notification handler code here
   CAutoCorrect *pAutoCorrect = (CAutoCorrect *)GetDlgItem( IDC_AUTOCORRECT1 );
   ASSERT( pAutoCorrect != NULL);   

   pAutoCorrect->AboutBox();
}

void CCorrectDlg::OnException() 
{
	// TODO: Add your control notification handler code here
   CAutoCorrect *pAutoCorrect = (CAutoCorrect *)GetDlgItem( IDC_AUTOCORRECT1 );
   ASSERT( pAutoCorrect != NULL);   

   UpdateData( TRUE ); //get edit box content

   if( pAutoCorrect -> IsCapitalizeException( m_strWord ) )
        m_strWord = "True";
   else
        m_strWord = "False";

   UpdateData( FALSE ); //set edit box content
}

void CCorrectDlg::OnCorrectWord() 
{
	// TODO: Add your control notification handler code here
   CAutoCorrect *pAutoCorrect = (CAutoCorrect *)GetDlgItem( IDC_AUTOCORRECT1 );
   ASSERT( pAutoCorrect != NULL);   

   WCHAR  szCorrect[50];
   
   UpdateData( TRUE ); //get edit box content

   BSTR pStr = &szCorrect[0];
   pAutoCorrect -> GetCorrectWord( m_strWord, &pStr );

   m_strWord = pStr;

   UpdateData( FALSE ); //set edit box content
}

BOOL CCorrectDlg::FileExists( LPCSTR lszFile ) 
{
   CFileStatus fs;
   return CFile::GetStatus( lszFile, fs );
}