// EditorView.cpp : implementation of the CEditorView class
//

#include "stdafx.h"
#include "Editor.h"

#include "EditorDoc.h"
#include "EditorView.h"
#include "SpellTxt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorView

IMPLEMENT_DYNCREATE(CEditorView, CEditView)

BEGIN_MESSAGE_MAP(CEditorView, CEditView)
	//{{AFX_MSG_MAP(CEditorView)
	ON_COMMAND(ID_EDIT_SPELLING, OnEditSpelling)
	ON_COMMAND(ID_SPELLING_DOWNLOADDICTIONARIES, OnSpellingDownloadDictionaries)
	ON_COMMAND(ID_SPELLING_OPTIONS, OnSpellingOptions)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorView construction/destruction

CEditorView::CEditorView()
{
	// TODO: add construction code here

}

CEditorView::~CEditorView()
{
}

BOOL CEditorView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	return bPreCreated;
}


int CEditorView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CEditView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
   SetFont(CFont::FromHandle((HFONT)GetStockObject(SYSTEM_FIXED_FONT)), FALSE);
	
	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CEditorView drawing

void CEditorView::OnDraw(CDC* pDC)
{
	CEditorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CEditorView diagnostics

#ifdef _DEBUG
void CEditorView::AssertValid() const
{
	CEditView::AssertValid();
}

void CEditorView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CEditorDoc* CEditorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEditorDoc)));
	return (CEditorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditorView message handlers

void CEditorView::OnEditSpelling() 
{
   TSpellText * pSpellText;
   int nBeginPos, nEndPos;
   char szDicFileName[FILENAME_MAX];
   
   // Get main dictionary file name
   strcpy(szDicFileName, g_szDictionaryDir);
   strcat(szDicFileName, g_szMainDictFileName);
   
   // Open dictionary
   g_SpellingChecker.OpenDictionary(szDicFileName, g_szCustomDictFileName);

   // Get spelling begin and end positions
   CEdit &EditCtrl = GetEditCtrl();
   EditCtrl.GetSel(nBeginPos, nEndPos);
   if(nBeginPos == nEndPos)
   {
      nEndPos = GetBufferLength();
   }
   // Spelling
   pSpellText = new TSpellText(this, &g_SpellingChecker);
   if(pSpellText->StartSpell(nBeginPos, nEndPos))
      AfxMessageBox("Spelling check is complete", MB_OK | MB_ICONEXCLAMATION);

   delete pSpellText;

   // Close dictionary
   g_SpellingChecker.CloseDictionary();
}

void CEditorView::OnSpellingDownloadDictionaries() 
{
   g_SpellingChecker.DownloadDictionaries("http://www.polarsoftware.com/install/dictionaries.ins", g_szDictionaryDir);
}

void CEditorView::OnSpellingOptions() 
{
   g_SpellingChecker.OptionsDialog(g_szDictionaryDir, g_szCustomDictFileName, FILENAME_MAX,
                                   g_szMainDictFileName, FILENAME_MAX, "http://www.polarsoftware.com/install/dictionaries.ins", TRUE);
}

